{ KOL MCK } // Do not remove this line!
{$DEFINE KOL_MCK}
unit Unit1;

interface

{$IFDEF KOL_MCK}
uses Windows, Messages, KOL {$IFNDEF KOL_MCK}, mirror, Classes, Controls, mckCtrls, mckObjs, Graphics {$ENDIF (place your units here->)},
  KOLPng, JpegObj;
{$ELSE}
{$I uses.inc}
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, mirror;
{$ENDIF}

type
  {$IFDEF KOL_MCK}
  {$I MCKfakeClasses.inc}
  {$IFDEF KOLCLASSES} {$I TForm1class.inc} {$ELSE OBJECTS} PForm1 = ^TForm1; {$ENDIF CLASSES/OBJECTS}
  {$IFDEF KOLCLASSES}{$I TForm1.inc}{$ELSE} TForm1 = object(TObj) {$ENDIF}
    Form: PControl;
  {$ELSE not_KOL_MCK}
  TForm1 = class(TForm)
  {$ENDIF KOL_MCK}
    KOLProject1: TKOLProject;
    KOLForm1: TKOLForm;
    Button1: TKOLButton;
    ck_filter_none: TKOLCheckBox;
    ck_filter_sub: TKOLCheckBox;
    ck_filter_up: TKOLCheckBox;
    ck_filter_avg: TKOLCheckBox;
    ck_filter_paeth: TKOLCheckBox;
    OpenSaveDialog1: TKOLOpenSaveDialog;
    Button2: TKOLButton;
    Button3: TKOLButton;
    procedure Button1Click(Sender: PObj);
    procedure Button2Click(Sender: PObj);
    procedure Button3Click(Sender: PObj);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1 {$IFDEF KOL_MCK} : PForm1 {$ELSE} : TForm1 {$ENDIF} ;

{$IFDEF KOL_MCK}
procedure NewForm1( var Result: PForm1; AParent: PControl );
{$ENDIF}

implementation

{$IFNDEF KOL_MCK} {$R *.DFM} {$ENDIF}

{$IFDEF KOL_MCK}
{$I Unit1_1.inc}
{$ENDIF}

procedure TForm1.Button1Click(Sender: PObj);
var j: PJpeg;
    p: PPngObject;
begin
  if OpenSaveDialog1.Execute then
  begin
    j := NewJpeg;
    j.LoadFromFile( OpenSaveDialog1.Filename );
    j.DIBNeeded;
    j.Bitmap.SaveToFile( GetStartDir + 'test.bmp' );
    p := NewPngObject;
    p.Filters := [];
    if ck_filter_none.Checked then
      p.Filters := p.Filters + [ pfNone ];
    if ck_filter_sub.Checked then
      p.Filters := p.Filters + [ pfSub ];
    if ck_filter_up.Checked then
      p.Filters := p.Filters + [ pfUp ];
    if ck_filter_avg.Checked then
      p.Filters := p.Filters + [ pfAverage ];
    if ck_filter_paeth.Checked then
      p.Filters := p.Filters + [ pfPaeth ];
    p.AssignHandle( j.Bitmap.ReleaseHandle, FALSE, 0 );
    p.SaveToFile( GetStartDir + 'test.png' );
    p.Free;
    j.Free;
  end;
end;

procedure TForm1.Button2Click(Sender: PObj);
var SrcStrm, FileStrm: PStream;
    p: PPngObject;
    i: Integer;
    Start: DWORD;
    b: PBitmap;
begin
  SrcStrm := NewMemoryStream;
  FileStrm := NewReadFileStream( GetStartDir + 'test.png' );
  p := NewPngObject;
  TRY
    SrcStrm.Size := FileStrm.Size;
    Stream2Stream( SrcStrm, FileStrm, FileStrm.Size );
    Start := GetTickCount;
    SetPriorityClass( GetCurrentProcess, REALTIME_PRIORITY_CLASS );
    for i := 1 to 100 do
    begin
      SrcStrm.Position := 0;
      FillChar( CountFilters, Sizeof( CountFilters ), 0 );
      p.LoadFromStream( SrcStrm );
    end;
    Start := GetTickCount - Start;
    SetPriorityClass( GetCurrentProcess, NORMAL_PRIORITY_CLASS );
    ShowMessage( 'Time: ' + Int2Str( Start ) + 'ms'#13#10 +
                 'none: ' + Int2Str( CountFilters[ pfNone ] ) + #13#10 +
                 'sub : ' + Int2Str( CountFilters[ pfSub ] ) + #13#10 +
                 'up  : ' + Int2Str( CountFilters[ pfUp ] ) + #13#10 +
                 'avg : ' + Int2Str( CountFilters[ pfAverage ] ) + #13#10 +
                 'paeth:' + Int2Str( CountFilters[ pfPaeth ] )
    );
    b := NewDibBitmap( p.Width, p.Height, pf32bit );
    p.Draw( b.Canvas.Handle, 0, 0 );
    b.SaveToFile( GetStartDir + 'test_unpk.bmp' );
    b.Free;
  FINALLY
    SrcStrm.Free;
    FileStrm.Free;
  END;
end;

procedure TForm1.Button3Click(Sender: PObj);
var s, s1, s2: String;
begin
  s := 'abcd'#0'efgh'#0;
  s1 := Parse( s, #0 );
  s2 := Parse( s, #0 );
  ShowMessage( s1 + #13#10 + s2 + #13#10 + s );
end;

end.



